local gr			= love.graphics
colors = require 'colors'

function love.load()
	love.window.setTitle("CSS Colors")
	alpha	= 1
	item	= colortables[1]
	font	= gr.getFont()
	end

function love.update( )
	local mo = {love.mouse.getPosition()}
	for i = 1, #colorbox do
		if PointinBox( mo, colorbox[i] ) then
			item = colortables[i]
			end
		end
	end

function love.draw()
	showGroup( item, 20, 10 )
	gr.setColor( 1, 1, 1 )
	gr.print( 'alpha ("a" key) = '..alpha, 650, 550 )
	gr.print( 'show code ("c" key)', 650, 562 )
	for i = 1, #colorbox do
		gr.setColor( colors[ colortables[i][1] ] )
		gr.rectangle( 'fill', unpack(colorbox[i]) )
		wd = font:getWidth( colororder[i] )
		gr.setColor( 0, 0, 0 )
		gr.print(colororder[i],colorbox[i][1]+colorbox[i][3]/2-wd/2,colorbox[i][2]+20)
		end
	end

function love.keypressed( key )
	if key == 'escape' then love.event.quit() end
	if key == 'a' then alpha = alpha > .3 and alpha - 0.1 or 1  print(alpha) end
	if key == 'c' then showCode = not showCode end
	end

showGroup = function( group,x, y )
	for i = 1, #group do
		gr.setColor( 1, 1, 1 )
		gr.print( group[i], x + 140, y+12 * i -1 )
		gr.setColor( colors[group[i]][1],colors[group[i]][2],colors[group[i]][3],alpha )
		gr.rectangle( 'fill', x, y+12*i, 135, 11 )
		if showCode then code( colors[ group[i] ], x+270, y, i, 3 ) end
		end
	end

code = function( clr, x, y, item, p )
	gr.setColor( 1,1,1 )
	local a, b, c = round(clr[1],p), round(clr[2],p), round(clr[3],p)
	local str = string.format( '{ %0.3f, %0.3f, %0.3f }', a, b, c )
	gr.print( str, x+2  , 12*item+y -2 )
	end

round = function( n, pl )
	return math.floor( 10^pl*(n + .5001/(10^pl))) / (10^pl)
	end
PointinBox = function( point, box )
	local x, y, w, h	= unpack( box )
	local px, py		= point[1], point[2]
	if px>=x and px<=x+w and py>=y and py<=y+h then return true end
	return false
	end
colorbox = {
	{500,10,50,50},
	{500,65,50,50},
	{500,120,50,50},
	{500,175,50,50},
	{500,230,50,50},
	{500,285,50,50},
	{500,340,50,50}
	}

other = {"Bisque","PeachPuff","Moccasin","PapayaWhip","Black"}

blue={"Blue","MidnightBlue","Indigo","Navy","DarkBlue","MediumBlue",
		"BlueViolet","CadetBlue","RoyalBlue","LightBlue",
		"CornflowerBlue","Violet","Plum","Teal","SteelBlue",
		"SkyBlue","SlateBlue","PowderBlue","Purple","RebeccaPurple",
		"PaleVioletRed","MediumVioletRed","Orchid","DarkOrchid",
		"MediumAquaMarine","MediumOrchid","MediumPurple",
		"MediumSlateBlue","DarkSlateBlue","LightSkyBlue","LightSteelBlue",
		"Lavender","LavenderBlush","DarkTurquoise","Turquoise",
		"MediumTurquoise","PaleTurquoise","DarkViolet","DeepSkyBlue",
		"DodgerBlue","DarkCyan","Cyan","Aqua","AquaMarine","Azure"}

white = {"White","Snow","MintCream","SeaShell","AliceBlue","LightCoral",
			"Beige","OldLace","WhiteSmoke","HoneyDew","Thistle",
			"DimGray","Gray","SlateGray","LightSlateGray","DarkGray",
			"Silver","LightGray","Gainsboro","Linen","Ivory",
			"GhostWhite","FloralWhite","BlanchedAlmond","NavajoWhite",
			"Wheat"}

green = {"Green","DarkSlateGray","DarkGreen","ForestGreen",
			"GreenYellow","LightGreen","LawnGreen","Chartreuse",
			"YellowGreen","PaleGreen","DarkOliveGreen","OliveDrab",
			"Olive","SpringGreen","MediumSpringGreen","DarkSeaGreen",
			"SeaGreen","MediumSeaGreen","LightSeaGreen","LimeGreen",
			"Lime"}

yellow = {"Gold","Yellow","LemonChiffon","Cornsilk",
			"LightYellow","PaleGoldenRod","LightGoldenRodYellow"}

brown = {"Brown","SandyBrown","Sienna","DarkGoldenRod","GoldenRod",
			"BurlyWood","Tan","Chocolate","Peru","Coral","RosyBrown",
			"SaddleBrown","DarkKhaki","Khaki"}

red = {"Red","Maroon","DarkRed","FireBrick","Crimson","OrangeRed",
		 "Tomato","Salmon","DarkSalmon","LightSalmon","Magenta","Fuchsia",
		 "DeepPink","HotPink","LightPink","Pink","IndianRed",
		 "DarkOrange","Orange","MistyRose"}

colororder = {'red','blue','green','white','brown','yellow','other'}
colortables = {red,blue,green,white,brown,yellow,other}